/*
 *  Eratostene.h
 *  AudioDrome
 *
 *  Created by Alessandro Petrolati on 16/02/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

//Crivello di Eratostene di Cirene
class connObj
	{
	public:
		connObj (connObj* in) : input(in){}
		connObj* input;
		virtual int out()=0;
	};

class intgen : public connObj
	{
	public:
		intgen (int v = 2) : connObj(0), val(v) {}
		virtual int out() 
		{
			return val++;
		}
		
	private:
		int val;
	};

class filter : public connObj
	{
	public:
		filter (connObj* in, int v) : connObj(in), val(v) {}
		virtual int out()
		{
			while (true) 
			{
				int n = input->out();
				if (n % val) 
					return n;
			}
		}
	private:
		int val;
	};

class sieve : public connObj
	{
	public:
		sieve (connObj* in) : connObj(in){}
		virtual int out()
		{
			int n = input->out();
			input = new filter(input, n);
			return n;
		}
	};


int main(int argc, char ** argv)
{
	intgen gen(2);
	sieve s(&gen);
	int next = 0;
	do {
		next = s.out();
		cout << next << " ";
	} while (next < 100);
	cout << endl;
}

//End of Crivello di Erostato
