/*
 *  Repository.cpp
 *  AudioDrome
 *
 *  Created by Alessandro Petrolati on 21/08/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include "Stk.h"
#include "RtWvIn.h"
#include "RtWvOut.h"
#include "FileWvIn.h"
#include "FileWvOut.h"
#include "AudioDromeAll.h"

int main (int argc, char* argv[])
{	
	
	AudioDrome::setAbsoluteSR(44100);
	Stk::setSampleRate( AudioDrome::getAbsoluteSR() );
	
	FileWvIn fileIn("/Users/alessandropetrolati/Documents/Suoni/Aurora.wav");
	FileWvOut fileOut("/Users/alessandropetrolati/Desktop/AudioDromeTest.wav", STEREO, FileWrite::FILE_WAV, Stk::STK_SINT16, 2);
	
	Granulator grn;	
	grn.setDefaults();
	OscilTimout* osc1 = new OscilTimout();
	osc1->setFrequency(440);
	osc1->setTime(10);
	osc1->setDownSampling(40);
	grn.setDownSampling(10);
	
	EUVerb euv;
	euv.setT60(10);
	
	Metronome mt(false);
	
	AudioOut dac;
	AudioIn adc;
	
	cout << "-----------------------------------" << endl;
	cout << "-----------------------------------" << endl;
	
	
	cout << "-----------------------------------" << endl;
	cout << "-----------------------------------" << endl;
	
	
	mt.setFrequency(0.5);
	for(unsigned int i = 0; i < AudioDrome::getAbsoluteSR() * 5; i++)
	{
		mt.PROCESSING();
		if(mt.Output())
		{
			//			AudioDrome::setAbsoluteSR(11025);
			osc1->setDownSampling(1);
			cout << "AbSR: " << AudioDrome::getAbsoluteSR() << " LcSR: " << osc1->getLocalSR() << endl;
		}
		
		
		adc.PROCESSING();
		dac.PROCESSING();
		grn.PROCESSING();
		osc1->PROCESSING();
		euv.PROCESSING();
		
		//		euv.Input_1( adc.Output_1() );
		//		dac.Input_1(euv.Output_1());
		//		dac.Input_2(euv.Output_2());
		
		adc >> (euv >> dac);
		dac << (euv << adc);
		//		dac << grn[LEFT];
		
		//		dac.Input( osc1->Output() );
		//		fileOut.tick( osc1->Output() );		
	}
	
	adc.abortStream();
	dac.abortStream();
}


#include "Stk.h"
#include "RtWvIn.h"
#include "RtWvOut.h"
#include "FileWvIn.h"
#include "FileWvOut.h"
#include "AudioDromeAll.h"

int main (int argc, char* argv[])
{	
	
	AudioDrome::setAbsoluteSR(44100);
	Stk::setSampleRate( AudioDrome::getAbsoluteSR() );
	
	FileWvOut fileOut("/Users/alessandropetrolati/Desktop/AudioDromeComparatore.wav", STEREO, FileWrite::FILE_WAV, Stk::STK_SINT16, 2);
	
	cout << "-----------------------------------" << endl;
	cout << "-----------------------------------" << endl;
	
	Analog anl;
	anl.setFrequency(440);
	anl.setOutputWaveform(SAWTOOTH);
	
	AudioOut dac;
	
	cout << "-----------------------------------" << endl;
	cout << "-----------------------------------" << endl;
	
	
	for(unsigned int i = 0; i < AudioDrome::getAbsoluteSR() * 10; i++)
	{
		anl.PROCESSING();
		dac.PROCESSING();
		dac << anl;
	}
}


/* OBSERVER PATTERN DESIGN*/
#include <iostream>
#include <set>

using namespace std;

// ---------------- Observer interface -----------------
class MyObserver {
public:
	virtual void Notify() = 0;
};

// ---------------- Observable object -------------------
class MyObservable {
	static MyObservable* instance;
	set<MyObserver*> observers;
	MyObservable() { };
public:
	static MyObservable* GetInstance();
	void AddObserver(MyObserver& o);
	void RemoveObserver(MyObserver& o);
	void NotifyObservers();
};

MyObservable* MyObservable::instance = NULL;

MyObservable* MyObservable::GetInstance()
{
    if ( instance == NULL ) {
		instance = new MyObservable();
    }
	
    return instance;
}

void MyObservable::AddObserver(MyObserver& o)
{
    observers.insert(&o);
}

void MyObservable::RemoveObserver(MyObserver& o)
{
    observers.erase(&o);
}

void MyObservable::NotifyObservers()
{
    set<MyObserver*>::iterator itr;
    for ( itr = observers.begin();
		 itr != observers.end(); itr++ )
		(*itr)->Notify();
}

// ------ Concrete class interested in notifications ---
class MyClass : public MyObserver {
	
	MyObservable* observable;
	
public:
	MyClass() {
		observable = MyObservable::GetInstance();
		observable->AddObserver(*this);
	}
	
	~MyClass() {
		observable->RemoveObserver(*this);
	}
	
	void Notify() {
		cout << "Received a change event in MyClass" << endl;
	}
};

class MyClassDerived : public MyClass
	{

//	public:
//		MyClassDerived() {
//			observable = MyObservable::GetInstance();
//			observable->AddObserver(*this);
//		}
//		
//		~MyClassDerived() {
//			observable->RemoveObserver(*this);
//		}
//		

		void Notify() {
		MyClass::Notify();
		cout << "Received a change event in MyClassDerived" << endl;
		}
		
	};


int main()
{
    MyObservable* observable = MyObservable::GetInstance();
//    MyClass* obj = new MyClass();
	MyClassDerived* obj2 = new MyClassDerived();
    observable->NotifyObservers();
}

///*******************************************************************/
///Developer section, most sperimental implementations.
///*******************************************************************/


#include "Stk.h"
#include "RtWvOut.h"
#include "RtWvIn.h"
#include "FileWvIn.h"
#include "FileWvOut.h"
#include "SineWave.h"
#include "FileWvOut.h"
#include "AudioDromeAll.h"

using namespace Aud;
using namespace std;

int main(int argc, char ** argv)
{
    ///Show header
    cout << "GenUnit, C++ Sound Classes developer" << endl
    <<"www.alessandro-petrolati.it" << endl
    << "info@alessandro-petrolati.it" << endl <<endl;

    Timer time;
    time.startTimer ();

//    ofstream fout ("shape.raw", ios::binary);
    FileWvOut output;
    unsigned short channels = 2;
    StkFrames frame(1,channels,false);
    try
    {
        /// Open a 16-bit, one-channel WAV formatted output file
        output.openFile( "shape.wav",channels, FileWrite::FILE_WAV, Stk::STK_SINT16 );
    }
    catch ( StkError & )
    {
        exit(0);
    }

//    File file ("AudioFiles/laltro32bit.raw");
//    file.importRaw ("AudioFiles/laltro32bit.raw")2;


    Window* fun1 = new Window (LENGTH);
    fun1->genHanning  ();
//    fun1->normalize();

    ///DEBUG OPCODE! ------------------------------

    Wave* test = new Wave (LENGTH);
    test->genArm (1,1);
//    test->genArm (2,.5);
//    test->genArm (3,.5);
//    test->genArm (4,.5);
//    test->genArm (5,.5);
//    test->genArm (6,.5);
//    test->genArm (7,.5);
//    test->genArm (8,.5);
//    test->genArm (9,.5);
//    test->genArm (10,.5);
//    test->genArm (11,.5);
//    test->genArm (12,.5);
//    test->genArm (13,.5);
//    test->genArm (14,.5);
//    test->genArm (15,.5);

//    test->normalize ();


    Window* win = new Window (LENGTH);
    win->genGaussian ();

    Wave* toadd = new Wave (LENGTH);
    toadd->genArm (1,.5);

    Wave* result = new Wave (LENGTH);
    result->genArm (1,1);
//    result->genSine ();
//    result->offSet(-.1);
//    result->normalize();
//    cout << result->getPeak();

//    *result = (*test + *toadd);
//    result = toadd->add(test);
//    result->clear();
//    result->add(win);
//    result->add(toadd);
//    result->copy(win);
//    result->resize (4000);
//    result->offSet (-.51324);
//    result->rescae(.1);
//    result->morphing(win,.8);
//    result->copy(win);

    AudFloat maxDel =.5;

    Oscillator* osc1 = new Oscillator(1,result,LINEAR);
    osc1->inArg(.5,1737);

    Oscillator* osc2 = new Oscillator(1,result,LINEAR);
    osc2->inArg(maxDel/2,1/10.0);

    VariableDelay del(1,1);
    del.setInterp3(true);

    BlockerDc * dcb = new BlockerDc();

    Phasor phs(1);
    Phasor php(1);
    phs.setFrequency(10);
    php.setFrequency(.1);

//    AudioIn adc(1);
//    adc.printHostDevices ();
//    adc.startStream ();
//    adc.selectDevice();

    AudioOut dac;
    dac.printHostDevices ();
    dac.startStream ();
    dac.selectDevice(2);

    ///--------------------------------------------

    for (unsigned int p = 0; p < 1 * P3 ; p++)
    {
        time.printTime ();
        del.setDelay ((osc2->getSignal() + maxDel)/2);
        AudFloat outLeft,outRigth;

        outLeft = del.getSignal(osc1->getSignal());///dcb->getSignal(osc->getSignal()); ///result->getMorph(phs.getSignal(),win,php.getSignal());///
        outRigth = outLeft;

        frame[LEFT] = (AudFloat) outLeft;
        frame[RIGTH] = (AudFloat) outRigth;


//        adc.getSignal(outLeft,outRigth);
        dac.putSignal(outLeft,outRigth);
//        dac (LEFT) << outLeft;
//        dac (RIGTH)  << outRigth;
        try
        {
            output.tickFrame (frame);
        }
        catch ( StkError & )
        {
            exit(0);
        }

        //        fout.write ((char*) &outLeft,  sizeof (outLeft));
    }

    dac.stopStream();
    output.closeFile ();
    cout <<endl << "Ho generato un file audio di " << P3 << " secondi." << endl;
    cout << "Performance avvenuta in " << time.elapsedTime()
    << " secondi" << endl;
//    cin.get ();
    return true;
}
///EOF


 Callback function
int tick_c(char *buffer, int bufferSize, void *dataPointer)
{
	// Pointer to "Chorus" from main
	Schroeder *rev = (Schroeder *) dataPointer;
	StkFloat *samples = (StkFloat *) buffer;

	// Passes RT _input through "chorus" to RT output
	for (int i=0; i<bufferSize; i++)
		*samples++ = rev->getSignal(*samples);

	return 0;
}

struct WAVEHDR
{
    char            format[4];         // RIFF
    unsigned long   f_len;             // filelength
    char            wave_fmt[8];       // WAVEfmt_
    unsigned long   fmt_len;           // format lenght
    unsigned short  fmt_tag;           // format Tag
    unsigned short  channel;           // Mono/Stereo
    unsigned long   samples_per_sec;
    unsigned long   avg_bytes_per_sec;
    unsigned short  blk_align;
    unsigned short  bits_per_sample;
    char            data[4];           // data
    unsigned long   data_len;          // data size
};

template<int i>
class C
	{
	public:
		enum {RES = i};
	};

template< ul N > 
struct powOfTwo
{
	const static ul val = 2 * powOfTwo< N-1 >::val;
};

template<> 
struct powOfTwo< 0 >
{
 	const static ul val = 1;
};


// C++
class TMyClass
	{
	public:
		int DoIt(float a, char b, char c){ cout << "TMyClass::DoIt: " << a+b+c << endl; return a+b+c;};
		int DoMore(float a, char b, char c) const
		{ cout << "TMyClass::DoMore" << a-b+c << endl; return a-b+c; };
		
		/* more of TMyClass */
	};


int main(int argc, char ** argv)
{
	

//	void (*ptVoid)(void) = NULL;
//	std::vector<void*> obj;
//	obj.push_back( &ptVoid );//static_cast<AudioDrome*>(ptTest));
	
	void (OscilTimout::*ptTest)(void) = NULL;
	ptTest = &OscilTimout::test;
	

	

	
	OscilTimout ot;
	(ot.*ptTest)();
	
	//std::bind1st( std::mem_fun(&OscilTimout::test), &ot );
	
	return 0;
	
	
	
	//	void (Oscillator::*setFrequencyPtr1)(const AudFloat &) = NULL;
	//	void (Oscillator::*setFrequencyPtr2)(const AudFloat &) const = NULL;
	int (TMyClass::*pt2Member)(float, char, char) = NULL;   // C++
	int (TMyClass::*pt2ConstMember)(float, char, char) const = NULL;     // C++
	
	
	//	void __cdecl DoIt(float a, char b, char c);                     // Borland and Microsoft
	void DoIt(float a, char b, char c)  __attribute__((cdecl));     // GNU GCC
	
	
	pt2ConstMember = &TMyClass::DoMore; // correct assignment using address operator
	pt2Member = &TMyClass::DoIt; // note: <pt2Member> may also legally point to &DoMore
	
	
	cout << "adress: " << &pt2Member << endl;
	
	
	if(pt2ConstMember == &TMyClass::DoMore)
		cout << "Pointer points to TMyClass::DoMore" << endl;
	
	TMyClass instance1;
	int result3 = (instance1.*pt2Member)(12, 'a', 'b');   // C++
	//	int result4 = (*this.*pt2Member)(12, 'a', 'b');       // C++ if this-pointer can be used
	
	TMyClass* instance2 = new TMyClass;
	int result4 = (instance2->*pt2Member)(12, 'a', 'b');  // C++, instance2 is a pointer
	delete instance2;
	
	return 1;
	
	
	
	
	///Show header
	cout << "GenUnit, C++ Sound Classes developer"<< endl
	<<"www.alessandro-petrolati.it"<< endl<< "info@alessandro-petrolati.it"
	<< endl << endl;
	
	// Set the global sample rate before creating class instances.
	Stk::setSampleRate(AudioDrome::getAbsoluteSR() );
	Stk::showWarnings( true);
	RtWvOut *dac = 0;
	//	RtAudio* dac;
	
	//RtAudioFormat format = (sizeof(StkFloat) == 8) ? RTAUDIO_FLOAT64 : RTAUDIO_FLOAT32;
	//int bufferSize = RT_BUFFER_SIZE;
	
	int channels = 2;
	long nFrames = 1;
	
	StkFrames frames(nFrames, channels);
	FileWvOut out;
	
	
	try
	{
		// Define and open the default realtime output device for one-channel playback
		dac = new RtWvOut(channels);
		//		dac = new RtAudio(0, 2, 0, 2, format, (int) AudioDrome::getAbsoluteSR(), &bufferSize, 0);
		//		dac->setStreamCallback(&tick_c, (void *)&rev);
		//		dac->startStream();
	}
	catch ( StkError & )
	{
		exit(0);
	}
	
	//	// Define and open a 16-bit, four-channel AIFF formatted output file
	//	try
	//	{
	//		out.openFile( "AudioDromeOut.wav", channels, FileWrite::FILE_WAV, Stk::STK_SINT16 );
	//	}
	//	catch (StkError &)
	//	{
	//		exit(0);
	//	}
	
	/* =========================== GENUNITS TESTS 	 =========================== */
	cout << " ========================================================================================= " << endl;
	cout << " ========================================================================================= " << endl;
	const int P3 = 10;	
	AudFloat sampleL, sampleR;
	Sample file;
	//	file.Buffer::resize(180000);
	file.setPath("/Users/alessandropetrolati/Documents/Suoni/");
	file.importWav("laltro22.wav");
	//file.importRaw("LALTRO22.wav", 22050);
	//file.printInfo();
		
	//Oscillator* osc = new Oscillator();
	//	osc->setFile(&file);
	//	osc->setDefaults();
	//	osc->setOverlap(20);
	//	osc->setWave(&file);
	//	osc->setWave(&file);
	//	osc->setFrequency( file.getNaturalFrequency() );
	
	AudioDrome::setAbsoluteSR(44100);
	
	
//	Wave square;
//	Window gaus;
//	square.genSine();
//	gaus.genGaussian();
//	
	//Oscillator gr(&file);
	//	gr.setFrequency(440);
	//	gr.setWave(&file);
	//	gr.setFrequency( file.getNaturalFrequency() );
	
	//	GranulatorSF gr;
	//	gr.setSample(&file);
	//	gr.setDensity(30);
	//	gr.setStart(0);
	//	gr.setEnd(1);
	//	gr.setSpeed(1);
	//	gr.setTimePointer(0);
	//	gr.setRndPitch(0);
	//	gr.setJittering(0);
	
//	Granulator* gr = new Granulator(&square, &gaus);
//	gr->setDensity(20);

	OscilTimout* gr = new OscilTimout();
	gr->setTime(10);
	gr->setFrequency(440);
	gr->start();

	AudioDrome::printNameListenersObj();	
	gr->ignoreAbsoluteSRChange();

	cout << endl << "CANCELLATO!================" << endl << endl;

	
	gr->listenAbsoluteSRChange();
	AudioDrome::printNameListenersObj();
	

	
	
	
	//	FILE *fp;
	//	WAVEHDR wav_h;
	//	fp = fopen("/Users/alessandropetrolati/Documents/Suoni/laltro22.wav","rb");
	
	
	//	fread((void*)&riff, 4, (size_t) 1, fp);
	//	
	//	if(strcmp(riff,"RIFF") == 0)
	//		cout << "RIFF" << endl;
	//	else if(strcmp(riff,"FORM") == 0)
	//			cout << "FORM" << endl;
	//	else
	//		cout << "RAW" << endl;
	
	//	char temp[4];
	//	fread((void*)&wav_h, sizeof(WAVEHDR), (size_t) 1, fp);
	//
	//	for(int i = 0; i < 4; i++) 
	//		temp[i] = wav_h.format[i];
	//	if(strcmp(temp,"RIFF") == 0)
	//		cout << "RIFF" << endl;
	//	else if(strcmp(wav_h.format,"FORM") == 0)
	//			cout << "FORM" << endl;
	//	else
	//		cout << "RAW" << endl;
	//	
	//	
	//	cout << endl << "∞∞∞∞∞∞∞∞∞∞ FILE INFORMATION ∞∞∞∞∞∞∞∞∞∞"<< endl <<endl;
	////	cout << "Sample Name: "<<  << endl;
	////	cout << "Path: "<< getPath() << endl;
	//	cout << "Number of Samples: " << wav_h.data_len << endl;
	//	cout << "Sample Sr: "<< wav_h.samples_per_sec << endl;
	////	cout << "Sample Channels: "<< getChannels() << endl;
	////	cout << "Sample Time Duration: "<< getDurationTime() << endl;
	//	cout << "Bits Per Sample = " << wav_h.bits_per_sample << endl;
	//	cout << "Number of Channels = " << wav_h.channel<< endl;
	//	cout << endl << "∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞∞"<< endl;
	//
	//	cin.get();
	
	
	
	cout << " ========================================================================================= " << endl;
	cout << " ========================================================================================= " << endl;
	/* ========================================================================================= */
	
	//	string s;
	//	for(int i = 0; i < AudioDrome::getNumberObjects(); i++)
	//	{
	//		s = AudioDrome::getObjPointer(i)->getClassName();
	//		cout << s << endl;
	//	}
	//	cout << AudioDrome::getNumberObjects();
	
	for (int i=0; i<3 * AudioDrome::getAbsoluteSR(); i++)
	{
		try
		{
			sampleL = gr->getSignal();// osc->getSignal();
			//			sampleR = osc->getSignalRigth();
			
			
			dac->tick( sampleL ); //for real time output
			//			out.tick( sampleR  );
		}
		catch ( StkError & )
		{
			goto cleanup;
		}
	}
	
	dac->stop();
	delete dac;
	AudioDrome::setAbsoluteSR(96000);
	Stk::setSampleRate(AudioDrome::getAbsoluteSR() );
	dac = new RtWvOut(channels);
	dac->start();	
	
	
	for (int i=0; i<3 * AudioDrome::getAbsoluteSR(); i++)
	{
		try
		{
			sampleL = gr->getSignal();// osc->getSignal();
			//			sampleR = osc->getSignalRigth();
			
			
			dac->tick( sampleL ); //for real time output
			//			out.tick( sampleR  );
		}
		catch ( StkError & )
		{
			goto cleanup;
		}
	}
	
	
	
cleanup: 
	delete dac;
	//	delete osc;
	
	
	cout <<endl << "Ho generato un file audio di "<< P3 << " secondi."<< endl;
	//	cin.get ();
	return true;
}


/* ............................................:::: CIM TEST 2 ::::............................................ */
/* Realt Time DAC Output*/
/* Hello grano! comiled with AudioDrome Stk-4.2.1 Debug or Release target */

#include "AudioDromeAll.h"
#include "RtWvOut.h"

int main(int argc, char ** argv)
{
	cout << "Hello grano!"<< endl;

	Stk::setSampleRate( AudioDrome::getAbsoluteSR() );
	RtWvOut dac(2, Stk::sampleRate());
	
	Granulator gr;
	
	for (long i = 0; i < 5 * AudioDrome::getAbsoluteSR(); i++)
	{
		dac.tick( gr.getSignal() );
	}
	
	return true;
}


int Oscil(const void *input, void *output,
		  unsigned long frameCount,
		  const PaStreamCallbackTimeInfo* timeInfo,
		  PaStreamCallbackFlags statusFlags,
		  void *userData )
{
	
	EUVerb *data = (EUVerb*)userData; 
	PaFloat *in = (PaFloat*)input;
	PaFloat *out = (PaFloat*)output;
	
	//		(void) inputBuffer; /* Prevent unused variable warning. */
	for( unsigned int i = 0; i < frameCount; i++ )
	{
		*out++ = data->Processing(*in++);  /* left */
		*out++ = data->getSignalRigth(); //*in++;  /* right */
		*in++;
		
	}
	return 0;
}


StkFrames& outFrames(StkFrames& frames, unsigned int channel)
{
	if (channel >= frames.channels() )
	{
		std::cout
		<< "Generator::tick(): channel and StkFrames arguments are incompatible!";
	}
	
	if (frames.channels() == 1)
	{
		for (unsigned int i=0; i<frames.frames(); i++)
			frames[i] = 0;//AudioDromeObject->Processing();
	}
	else if (frames.interleaved() )
	{
		unsigned int hop = frames.channels();
		unsigned int index = channel;
		for (unsigned int i=0; i<frames.frames(); i++)
		{
			frames[index] = 0; //AudioDromeObject->Processing();
			index += hop;
		}
	}
	else
	{
		unsigned int iStart = channel * frames.frames();
		for (unsigned int i=0; i<frames.frames(); i++, iStart++)
			frames[iStart] = 0;// AudioDromeObject->Processing();
	}
	return frames;
}


int main(int argc, char ** argv)
{
	AudioDrome::setAbsoluteSR(44100);
	
	Oscillator osc;
	osc.setFrequency(440);
	
	Granulator gr;
	gr.setWidth(1);
	
	EUVerb euv;
	euv.setT60(5);
	
	DelayLine del;
	del.setDelayTime(.5);
	
	
	AudioOut dac;
	AudioIn adc;
	
	AudFloat* frame;
	frame = new AudFloat[STEREO];

	for (long i = 0; i < 45 * AudioDrome::getAbsoluteSR(); i++)
	{
		AudFloat l,r,le,re;

//		adc.Processing(l,r);
//		le = euv.Processing(l);
//		re = euv.getSignalRigth();		
//		dac.Processing(le, re);
		
		
		
//		adc.Processing();
//		dac.Processing();
//		euv.Processing();
//		
//		osc.Processing();
//		dac.Processing( osc.Output() );
//		
//		dac << euv << adc;
//		
//		euv.Input( adc.Output() );
//		dac.Input( euv.Output() );
	}
	
	
	dac.stopStream();
	dac.closeStream();
	
	adc.stopStream();
	adc.closeStream();
}





#include "AudioDromeAll.h"
#include <iostream>
#include <slotsig_0.h>
#include <slotsig_1.h>
#include <slotsig_2.h>
#include <slotsig_3.h>
#include <slotsig_4.h>
#include <slotsig_5.h>
#include <slotsig_6.h>
#include <slotsig_7.h>
#include <slotsig_8.h> 

class base : public SlotSig::SlotsSetBase
{
public:
	base() : SlotSig::SlotsSetBase() 
	{ 	
		sig.connect(this, &base::fun); 
	}
	
	~base() 
	{ 
		sig.disconnect(this, &base::fun);
	}
	
	void fun(void)
	{ 
		cout << " funzione classe base " << this << endl;
	}
	
	void remove()
	{
		SlotSig::Sig0<void>::const_iterator iter = sig.begin() ;

		while ( iter != sig.end() )
		{			
			SlotSig::Slot0<void>* slot = *iter ;
			if ( slot != 0 )
			{
				void* in_class = slot->in_class_void() ;
				std::cout << "Slot, in class " << in_class ;
				if ( in_class != 0 )
				{
//					if ( in_class == this )
						std::cout << " SlotSet" ;
//					else
//						if ( in_class == &other_class )
//							std::cout << " OtherClass" ;
//						else
//							std::cout << " <unknown>" ;
					SlotSig::SlotsSetBase * in_base = slot->in_base() ;
					if ( in_base == 0 )
						std::cout << " (unmanaged)\n" ;
					else
						std::cout << " (SlotsSetBase-based)\n" ;
				}
				else
				{
					std::cout << " ==> it's a global function, " ;
					SlotSig::SlotGlobal0<void>* slot_global =
					dynamic_cast<SlotSig::SlotGlobal0<void>*>(slot) ;
					std::cout << std::hex << (void*)(slot_global->the_slot()) << "\n" ;
				}
			}
			++iter ;
		}
	}
		
		
		void run() 
		{
			sig.run();
		}
		
	protected:
		SlotSig::Sig0<void> sig;
	};
	
	
	class derived : public base
		{
		public:
			derived()
			{ 	
				sig.connect(this, &derived::fun); 
			}
			
			~derived() 
			{ 
				sig.disconnect(this, &base::fun);
			}
			
			void fun(void)
			{ 
				cout << " funzione classe derived " << this << endl;
			}
		};
	
	class derivedTwo : public derived
		{
		public:
			derivedTwo()
			{ 	
				sig.connect(this, &derivedTwo::fun); 
			}
			
			~derivedTwo() 
			{ 
				sig.disconnect(this, &base::fun);
			}
			
			void fun(void)
			{ 
				cout << " funzione classe derivedTwo " << this << endl;
			}
		};
	
	int main (int argc, char* argv[])
	{
		
		derivedTwo d;
		d.run();
		d.remove();
		return 0 ;
	}



#include <iostream>
#include <slotsig_0.h>
void f()
{ 
	std::cout << "::f()\n" ; 
}

class SlotSet : public SlotSig::SlotsSetBase
{
public:
    void m() { std::cout << "SlotSet::m()\n" ; }
    void m2() { std::cout << "SlotSet::m2()\n" ; }
};

class OtherClass
	{
	public:
		virtual ~OtherClass() { }
		void m() { std::cout << "OtherClass::m()\n" ; }
		void m2() { std::cout << "OtherClass::m2()\n" ; }
	} ;
int main (int argc, char* argv[])
{
	SlotSig::Sig0<void> sig ;
	SlotSet slot_set ;
	OtherClass other_class ;
	sig.connect(f) ;
	sig.connect(&slot_set, &SlotSet::m) ;
	sig.connect(&slot_set, &SlotSet::m2) ;
	sig.connect(&other_class, &OtherClass::m) ;
	sig.connect(&other_class, &OtherClass::m2) ;
	SlotSig::Sig0<void>::const_iterator iter = sig.begin() ;
	while ( iter != sig.end() )
	{
		SlotSig::Slot0<void>* slot = *iter ;
		if ( slot != 0 )
		{
			void* in_class = slot->in_class_void() ;
			std::cout << "Slot, in class " << in_class ;
			if ( in_class != 0 )
			{
				if ( in_class == &slot_set )
					std::cout << " SlotSet" ;
				else
					if ( in_class == &other_class )
						std::cout << " OtherClass" ;
					else
						std::cout << " <unknown>" ;
				SlotSig::SlotsSetBase * in_base = slot->in_base() ;
				if ( in_base == 0 )
					std::cout << " (unmanaged)\n" ;
				else
					std::cout << " (SlotsSetBase-based)\n" ;
			}
			else
			{
				std::cout << " ==> it's a global function, " ;
				SlotSig::SlotGlobal0<void>* slot_global =
				dynamic_cast<SlotSig::SlotGlobal0<void>*>(slot) ;
				std::cout << std::hex << (void*)(slot_global->the_slot()) << "\n" ;
			}
		}
		++iter ;
	}
	SlotSig::about_to_delete(&other_class) ;
	return 0 ;
}











#include "AudioDromeAll.h"
#include <iostream>
#include <boost/bind.hpp>
#include <boost/signals/signal0.hpp>
#include <boost/signals/signal2.hpp>
#include <iostream>

static boost::signal0<void> _signal;

class Base
	{
	public:
		Base()
		{
			_signal.connect(boost::bind(&Base::upDateSR, this));
		}
		
		virtual ~Base()
		{
			_signal.disconnect(boost::bind(&Base::upDateSR, this));
		}
		
		static void setAbsoluteSR(const AudFloat& sr)
		{
			_absoluteSRtest = sr;
			_signal();
		}
		
		//! Not be a virtual function, because it need to update all inehrit member function.
		void upDateSR()
		{
			std::cout << "drenta Base: " << _absoluteSRtest<< std::endl;
		}
		
	protected:
		static AudFloat _absoluteSRtest;
		static boost::signal0<void> _signal;
	};


AudFloat Base::_absoluteSRtest = 44100;
boost::signal0<void> Base::_signal;

class Derived : public Base
	{
	public:
		Derived()
		{
			_signal.connect(boost::bind(&Derived::upDateSR, this));
		}
		
		~Derived()
		{
			_signal.disconnect(boost::bind(&Derived::upDateSR, this));
		}
		
		void upDateSR()
		{
			std::cout << "drenta Derived: " << _absoluteSRtest<< std::endl;
		}
		
	};


class DerivedTwo : public Derived
	{
	public:
		DerivedTwo()
		{
			_signal.connect(boost::bind(&DerivedTwo::upDateSR, this));
		}
		
		~DerivedTwo()
		{
			_signal.disconnect(boost::bind(&DerivedTwo::upDateSR, this));
		}
		
		
		void upDateSR()
		{
			std::cout << "drenta DerivedTwo: " << _absoluteSRtest<< std::endl;
		}
		
	};

class Duplex : virtual public Derived, virtual public DerivedTwo
{
public:
	Duplex()
	{
		_signal.connect(boost::bind(&Duplex::upDateSR, this));
	}
	
	~Duplex()
	{
		_signal.disconnect(boost::bind(&Duplex::upDateSR, this));
	}
	
	
	void upDateSR()
	{
		std::cout << "drenta Duplex: " << _absoluteSRtest<< std::endl;
	}
};

int main (int argc, char* argv[])
{
	//	Base* doc = new Base();
	//	Duplex* doc2 = new Duplex();
	//	Base::setAbsoluteSR(3399);
	//	
	//	cout << "delete" << endl;
	//	
	//	delete doc2;
	//	delete doc;
	//	
	//	Base::setAbsoluteSR(3399);
	
	//	Oscillator* osc = new Oscillator();
	//	Phasor* ph = new Phasor();
	//	OscilTimout* osct = new OscilTimout();
	//
	//	AudioDrome::setAbsoluteSR(22050);
	//	std::cout << "------------------------" << std::endl;
	//
	//	osct->ignoreAbsoluteSRChange();
	////	AudioDrome::_signal.disconnect(boost::bind(&OscilTimout::srUpdate, osct));
	//
	//	//	delete osct;
	//
	//	AudioDrome::setAbsoluteSR(32050);
	//	std::cout << "------------------------" << std::endl;
	//
	////	AudioDrome::_signal.disconnect(boost::bind(&Phasor::srUpdate, ph));
	//	ph->ignoreAbsoluteSRChange();
	////	delete ph;
	////	delete osc;
	//
	//	AudioDrome::setAbsoluteSR(32051);
	//	std::cout << "------------------------" << std::endl;
	//	
	//	
	//	
	//	std::cout << "------------------------" << std::endl;
	//	std::cout << "------------------------" << std::endl;
	//	
	//	osct->listenAbsoluteSRChange();
	//		osct->listenAbsoluteSRChange();
	//		ph->listenAbsoluteSRChange();
	//		osct->listenAbsoluteSRChange();
	//	ph->listenAbsoluteSRChange();
	//	
	
	
	AudioDrome::setAbsoluteSR(44100);
	
	Granulator grn;	
	grn.setDefaults();
	OscilTimout* osc1 = new OscilTimout();
	osc1->setFrequency(440);
	osc1->setTime(10);
	osc1->setDownSampling(10);
	
	EUVerb euv;
	euv.setT60(10);
	
	Metronome mt(false);
	
	AudioOut dac;
	AudioIn adc;
	
	cout << "-----------------------------------" << endl;
	cout << "-----------------------------------" << endl;
	
	//	dac.ignoreAbsoluteSRChange();
	//	grn->ignoreAbsoluteSRChange();
	//	osc1->ignoreAbsoluteSRChange();
	//	osc2.ignoreAbsoluteSRChange();
	
	//	delete grn;
	cout << "-----------------------------------" << endl;
	cout << "-----------------------------------" << endl;
	
	
	mt.setFrequency(0.5);
	for(unsigned int i = 0; i < AudioDrome::getAbsoluteSR() * 15; i++)
	{
		mt.Processing();
		if(mt.Output_1())
		{
			//			AudioDrome::setAbsoluteSR(11025);
			osc1->setDownSampling(1);
			cout << "AbSR: " << AudioDrome::getAbsoluteSR() << " LcSR: " << osc1->getLocalSR() << endl;
		}
		
		
		adc.Processing();
		dac.Processing();
		grn.Processing();
		osc1->MAKE();
		euv.Processing();
		
		//		euv.Input_1( adc.Output_1() );
		//		dac.Input_1(euv.Output_1());
		//		dac.Input_2(euv.Output_2());
		
		//		adc >> (euv >> dac);
		//		dac << (euv << adc);
		//		dac << grn[LEFT];
		
		dac.Input_1( osc1->Output_1() );
	}
	
	adc.closeStream();
	dac.closeStream();
	adc.abortStream();
	dac.abortStream();
	
}



class base
{
public:
	base()
	{ 	
		sig.connect(this, &base::fun); 
	}
	
 ~base() 
	{ 
		sig.disconnect(this, &base::fun);
	}
	
	void fun(void)
	{ 
		cout << " funzione classe base " << this << endl;
	}
	
	void run() 
	{
		sig.run();
	}
	
protected:
	boost::signal<void> sig;
};


class derived : public base
	{
	public:
		derived()
		{ 	
			sig.connect(this, &derived::fun); 
		}
		
 ~derived() { sig.disconnect(this, &base::fun);}
		void fun(void)
		{ 
			cout << " funzione classe derived " << this << endl;
		}
	};

class derivedTwo : public derived
	{
	public:
		derivedTwo()
		{ 	
			sig.connect(this, &derivedTwo::fun); 
		}
		
 ~derivedTwo() { sig.disconnect(this, &base::fun);}
		void fun(void)
		{ 
			cout << " funzione classe derivedTwo " << this << endl;
		}
	};

int main (int argc, char* argv[])
{
	derivedTwo d;
	d.run();
	return 0 ;
}




 Boost C++ Thread experimental 1
 Copyright (C) 2001-2003
 William E. Kempf

  Distributed under the Boost Software License, Version 1.0. (See accompanying 
  file LICENSE_1_0.txt or copy at http://www.boost.org/LICENSE_1_0.txt)

#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>
#include <iostream>
#include <AudioDromeAll.h>

using namespace Aud;

Oscillator osc, osc2, osc3;
Phasor ph;

AudioOut dac;
AudioOut dac2;

boost::mutex io_mutex;

void thread_1()
{
	ph.setFrequency(1);
	AudFloat mod;
	
	while(true)
	{
		mod = ph.Processing();
		osc.setFrequency(440 + (mod*100));
		osc2.setFrequency(550 - (mod*100));
		dac.Processing( osc.Processing(), osc2.Processing());
	}
}


void thread_2()
{
	osc3.setFrequency(1400);
	dac2.setDevice(dac.getDefaultInputDevice() + 1);
	dac2.printAllHostDevices();
	int i = 6;
	cin >> i;
	dac2.setDevice(i);
	
	while(true)
	{
		dac2.Processing( osc3.Processing(), 0);
	}
}


int main(int argc, char* argv[])
{	
    boost::thread thrd1(&thread_1);
	boost::thread thrd2(&thread_2);
	
	thrd1.join();
	thrd2.join();
}



 Boost C++ Thread experimental 2
#include <boost/thread/thread.hpp>
#include <boost/bind.hpp>
#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/thread/tss.hpp>
#include <iostream>
#include <AudioDromeAll.h>

using namespace Aud;


Oscillator osc, osc2;
AudioOut dac;
boost::mutex io_mutex;
boost::thread_specific_ptr<int> ptr;

void oscil()
{
	while(1)
	{
		
		boost::mutex::scoped_lock
		lock(io_mutex);

		osc.Processing();
	}
}

void oscil2()
{
	while(1)
	{
		boost::mutex::scoped_lock
		lock(io_mutex);

		osc2.Processing();
	}
}



int main(int argc, char* argv[])
{
    boost::thread thrd1(&oscil);
	boost::thread thrd2(&oscil2);

//	thrd1.join();
//	thrd2.join();

	//	
	//	boost::thread thrd2(boost::bind(&oscil, 3311));
	//    thrd2.join();

	
	while (true)
	{
		dac.Processing(osc._sample, osc2._sample);
	}
}



/* ............................................:::: CIM TEST 2 ::::............................................ */
/* Realt Time EuVerb In/Out in the DAC and/or AudioFile */
/* EUVerb comiled with AudioDrome Stk-4.2.1 Debug or Release target */

#include "Stk.h"
#include "RtWvIn.h"
#include "RtWvOut.h"
#include "FileWvIn.h"
#include "FileWvOut.h"
#include "AudioDromeAll.h"


int main(int argc, char ** argv)
{
	///Show header
	cout << "EUVerb_03" <<endl << "Modelling by Eugenio Giordani" << endl << "Implementation by Alessandro Petrolati with AudioDrome C++ Classes"<< endl
	<<"www.eugenio-giordani.it" << endl << "www.alessandro-petrolati.com"<< endl<< "info@eugenio-giordani.it" << endl
	<<"info@alessandro-petrolati.it" << endl <<endl;
	
	Stk::setSampleRate( AudioDrome::getAbsoluteSR() );
	
	unsigned int channels = 2;
	int device = 0;
	int bufferFrames = RT_BUFFER_SIZE; //512 default
	int nBuffers = 20;
	
	unsigned int nFrames = 2;
	unsigned int nChannels = channels;
	bool interleaved = true;	
	
	RtWvOut dac(channels, Stk::sampleRate(), device, bufferFrames,nBuffers);
	RtWvIn adc(channels, Stk::sampleRate(), device, bufferFrames,nBuffers);
	
	StkFrames frame(nFrames, nChannels, interleaved);
	
	FileWvIn fileIn("/Users/alessandropetrolati/Documents/Suoni/Aurora.wav");
	FileWvOut fileOut("/Users/alessandropetrolati/Desktop/EuVerbTest.wav", nChannels, FileWrite::FILE_WAV, Stk::STK_SINT16, nFrames);
	
	Aud::EUVerb euv;
	
	euv.setT60(7);
	euv.setInperpolation(LINEAR);
	euv.setReverberatedLevel(0.9);
	euv.setDirectLevel(0.1);
	
	for (long i = 0; i < 5 * AudioDrome::getAbsoluteSR(); i++)
	{
		
		for(int w = 0; w <  nChannels; w++)
		{
			frame[w] =  euv.getSignal( fileIn.tick() ); 					
			frame[w+channels] = euv.getSignalRigth();
		}
		fileOut.tickFrame(frame);		
	}
	
	return true;
}









/* ............................................:::: CIM TEST 3 ::::............................................ */
/* Realt Time EuVerb In/Out only DAC with callBack function  */
/* EUVerb 2008*/
/* This main use Real Tiame Audio from Stk-4.3.1 */
/* For better Compiling using AudioDrome Stk-4.3.1 xCode Target */

#include "Stk.h"
#include "RtAudio.h"
#include "AudioDrome.h"
#include "AudioDromeAll.h"

int reverbCallBack( void *outputBuffer, void *inputBuffer, unsigned int nBufferFrames,
				   double streamTime, RtAudioStreamStatus status, void *dataPointer )
{
	myObj* dsp = (myObj*) dataPointer;
	register StkFloat* in = (StkFloat*) inputBuffer;
	register StkFloat *out = (StkFloat *) outputBuffer;
	
	for ( unsigned int i=0; i<nBufferFrames; i++ )
	{
		if(dsp->stereo)
		{
			//Stereo _input
			*out++ = dsp->euvL.getSignal(*in++);
			*out++ = dsp->euvR.getSignal(*in++);
		}
		else
		{
			//Mono _input
			*out++ = dsp->euvL.getSignal(*in++);
			*out++ = dsp->euvL.getSignalRigth();
			*in++; //use only Left Channel and increment rigth for sync to output buffer pointer
		}
	}
	
	return 0;
}

int main(int argc, char ** argv)
{
	///Show header
	cout << "EUVerb_03" <<endl << "Modelling by Eugenio Giordani" << endl << "Implementation by Alessandro Petrolati with AudioDrome C++ Classes"<< endl
	<<"www.eugenio-giordani.it" << endl << "www.alessandro-petrolati.com"<< endl<< "info@eugenio-giordani.it" << endl
	<<"info@alessandro-petrolati.it" << endl <<endl;
	
	// Set the global sample rate before creating class instances.
	Stk::setSampleRate( Aud::AudioDrome::getAbsoluteSR() );
		
	myObj dsp;
	
	dsp.euvL.setNoiseInject(0.00000000001);
	dsp.euvL.setLowShelfEqParam(20, 0);
	dsp.euvL.setHighShelfEqParam(2000, 0);
	dsp.euvL.setPeakEqParam(20,  0);
	dsp.euvL.setEarlyTimeScale(1.0); //da 0.35 a 4.0
	dsp.euvL.setAllPassTimeScale(1.5); //da 0.2 a 4
	dsp.euvL.setAllPassGain(0.5); //da 0.1 a 0.9
	dsp.euvL.setCombTimeScale(1.5);
	dsp.euvL.setT60(1.5);
	dsp.euvL.setCombCutOff(12000);
	
	dsp.euvL.setT60(4);
	dsp.euvL.setInperpolation(DISABLED);
	dsp.euvL.setReverberatedLevel(0.9);
	dsp.euvL.setDirectLevel(0.1);
	dsp.euvL.setDirectDelay(.001);
	dsp.euvL.setPreDelay(.001);

	dsp.euvR.setNoiseInject(0.00000000001);
	dsp.euvR.setLowShelfEqParam(20, 0);
	dsp.euvR.setHighShelfEqParam(2000, 0);
	dsp.euvR.setPeakEqParam(20,  0);
	dsp.euvR.setEarlyTimeScale(1.0); //da 0.35 a 4.0
	dsp.euvR.setAllPassTimeScale(1.5); //da 0.2 a 4
	dsp.euvR.setAllPassGain(0.5); //da 0.1 a 0.9
	dsp.euvR.setCombTimeScale(1.5);
	dsp.euvR.setT60(1.5);
	dsp.euvR.setCombCutOff(12000);
	
	dsp.euvR.setT60(4);
	dsp.euvR.setInperpolation(DISABLED);
	dsp.euvR.setReverberatedLevel(0.9);
	dsp.euvR.setDirectLevel(0.1);
	dsp.euvR.setDirectDelay(.001);
	dsp.euvR.setPreDelay(.001);
	
	dsp.stereo = true;
	
	RtAudio dac;
	
	// Figure out how many bytes in an StkFloat and setup the RtAudio stream.
	RtAudio::StreamParameters outParam;
	
	outParam.deviceId = dac.getDefaultOutputDevice();
	outParam.nChannels = 2;
	
	RtAudio::StreamParameters inParam;
	inParam.deviceId = dac.getDefaultInputDevice();
	inParam.nChannels = 2;
	
	RtAudioFormat format = ( sizeof(AudFloat) && sizeof(AudFloat) == 8 ) ? RTAUDIO_FLOAT64 : RTAUDIO_FLOAT32;
	
	unsigned int bufferFrames = RT_BUFFER_SIZE;
	
	try {
		dac.openStream( &outParam, &inParam, format, (unsigned int) Aud::AudioDrome::getAbsoluteSR(), &bufferFrames, &reverbCallBack, (void* )&dsp );
	}
	catch ( RtError &error ) {
		error.printMessage();
		goto cleanup;
	}
	
	try {
		dac.startStream();
	}
	catch ( RtError &error ) {
		error.printMessage();
		goto cleanup;
	}
	
	// Block waiting here.
	char keyhit;
	std::cout << "\nPlaying ... press <enter> to quit.\n";
	std::cin.get( keyhit );
	
	// Shut down the output stream.
	try {
		dac.closeStream();
	}
	catch ( RtError &error ) {
		error.printMessage();
	}
	
cleanup:
	
	return 0;
}
///EOF