/***************************************************/
/*! \class AudioDromeAll
 \brief
 
 This file include all AudioDrome header file.
 
 by Alessandro Petrolati 2006.
 www.alessandro-petrolati.it
 info@alessandro-petrolati.it
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public
 License as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.
 
 You should have received a copy of the GNU Library General Public
 License along with this library; if not, write to the Free
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/***************************************************/
#ifndef AUDIODROMEALL_H_
#define AUDIODROMEALL_H_

#include "AudioDrome.h"
#include "AudError.h"

#ifdef __WITH_PORTAUDIO__
#include "AudioIn.h"
#include "AudioIO.h"
#include "AudioOut.h"
#include "AudioDuplex.h"
#endif

#include "AllPass.h"
#include "Analog.h"
#include "BandPass.h"
#include "BandReject.h"
#include "BlockerDc.h"
#include "BP_Butterworth.h"
#include "BR_Butterworth.h"
#include "BreakCurve.h"
#include "BreakLine.h"
#include "Buffer.h"
#include "Comb.h"
#include "Curve.h"
#include "DecodeDTMF.h"
#include "DelayLine.h"
#include "DelayTaps.h"
#include "Distortion.h"
#include "Envelops.h"
#include "EUVerb.h"
#include "Flanger.h"
#include "Gaussian.h"
#include "GenerateDTMF.h"
#include "Granulator.h"
#include "GranulatorSF.h"
#include "HighPass.h"
#include "HoldRandom.h"
#include "HP_Butterworth.h"
#include "Interpolation.h"
#include "InterpRandom.h"
#include "KarplusStrong.h"
#include "Line.h"
#include "LowPass.h"
#include "LP_Butterworth.h"
#include "Metronome.h"
#include "MoogLadder.h"
#include "Oscillator.h"
#include "OscilTimout.h"
#include "ParametricEQ.h"
#include "Phasor.h"
#include "Random.h"
#include "RmsBalance.h"
#include "Sample.h"
#include "Schroeder.h"
#include "Sinusoide.h"
#include "Timer.h"
#include "Trapezoid.h"
#include "Trigger.h"
#include "UpSampling.h"
#include "Wave.h"
#include "Window.h"
#endif /*AUDIODROMEALL_H_*/

