/***************************************************/
/*! \class BreakCurve
 \brief
 
 The AudioDrome BreakCurve class, constructs of the segments 
 between two points expressed like Time-value. 
 The segments, they can assume a specific curving through setCurve().
 
 by Alessandro Petrolati 2006.
 www.alessandro-petrolati.it
 info@alessandro-petrolati.it
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public
 License as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.
 
 You should have received a copy of the GNU Library General Public
 License along with this library; if not, write to the Free
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/***************************************************/

#ifndef BREAKCURVE_H
#define BREAKCURVE_H

#include "Curve.h"
#include "BreakLine.h"

//  begin namespace
namespace Aud
{
	class BreakCurve : public Curve, public BreakLine
	{
	public:
		
		//! Public constructor
		BreakCurve();
		
		//! Public destructor
		virtual ~BreakCurve();
		
	protected:
		//! Processing the audio sample
		/*!
		 * The function calls the breakPoint(),
		 * this protected function maintains 
		 * trace of the performed segments. 
		 * The return value is calculated 
		 * from the Curve::Processing() function.
		 */
		virtual void Processing();
	};
} //	end of namespace Aud
#endif
///EOF

