/***************************************************/
/*! \class HP_Butterworth Filter
 \brief
 
 The AudioDrome HP_Butterworth class, implements a 
 high-pass Butterworth filter. 
 Coded by Paris Smaragdis 1994
 
 Csound's code butter.c
 
 by Alessandro Petrolati 2006.
 www.alessandro-petrolati.it
 info@alessandro-petrolati.it
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public
 License as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.
 
 You should have received a copy of the GNU Library General Public
 License along with this library; if not, write to the Free
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/***************************************************/

#ifndef HP_BUTTERWORTH_H_
#define HP_BUTTERWORTH_H_

#include "LP_Butterworth.h"

//  begin namespace
namespace Aud
{
	class HP_Butterworth : public LP_Butterworth
		{
		public:
			//! Public constructor
			HP_Butterworth(const AudFloat &cutOff=500);
			
			//! Public destructor
			virtual ~HP_Butterworth();
			
			//! Sets the cut-off frequency in hz
			virtual void setCutOff(const AudFloat &cutOff);
		};
} //	end of namespace Aud
#endif /*HP_BUTTERWORTH_H_*/
///EOF
