/***************************************************/
/*! \class HighPass Filter
 \brief
 
 The AudioDrome HighPass class, implements a first-order filter.
 
 Csound's code, based on Robin Whittle's
 ugrw2.c and ugrw2.h of 9 September 1995
 
 by Alessandro Petrolati 2006.
 www.alessandro-petrolati.it
 info@alessandro-petrolati.it
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public
 License as published by the Free Software Foundation; either
 version 2 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.
 
 You should have received a copy of the GNU Library General Public
 License along with this library; if not, write to the Free
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/***************************************************/

#ifndef HIGHPASS_H_
#define HIGHPASS_H_

#include "LowPass.h"

namespace Aud
{
	class HighPass : public LowPass
		{
		public:
			
			//! Public constructor
			HighPass(const AudFloat &cutOff=10000);
			
			//! Public destructor
			virtual ~HighPass();
			
		protected:
			//! Processing the audio sample
			virtual void Processing();
		};
}//	end of namespace Aud
#endif /*HIGHPASS_H_*/
